var TermBlasterOptions = {  
  onLoad: function() {
    this.txtDatabaseLocation = document.getElementById("txtDatabaseLocation");
    this.txtQuickListLocation = document.getElementById("txtQuickListLocation");
    this.rgDestination = document.getElementById("rgDestination");
    
    this.populate(this.txtDatabaseLocation);
    this.populate(this.txtQuickListLocation);
    
    var prefs = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefBranch);
    if (prefs.getPrefType("extensions.termblaster.opened.database") == prefs.PREF_STRING)
      this.txtDatabaseLocation.value = prefs.getCharPref("extensions.termblaster.opened.database");
    if (prefs.getPrefType("extensions.termblaster.opened.quicklist") == prefs.PREF_STRING)
      this.txtQuickListLocation.value = prefs.getCharPref("extensions.termblaster.opened.quicklist");
    if (prefs.getPrefType("extensions.termblaster.destination") == prefs.PREF_INT)
      this.rgDestination.selectedIndex = prefs.getIntPref("extensions.termblaster.destination");
  },

  btnBrowseCommand: function(txtField) {
    var nsIFilePicker = Components.interfaces.nsIFilePicker;
    var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);

    fp.init(window, "Select a File", nsIFilePicker.modeOpen);
    fp.appendFilter("termBlaster Files", "*.tbd; *.tbq");

    if (fp.show() == nsIFilePicker.returnOK && fp.fileURL.spec && fp.fileURL.spec.length > 0) {
      var thefile = fp.file;
      txtField.value = fp.fileURL.spec;
    }
  },

  btnOkCommand: function() {
    var prefs = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefBranch);

    prefs.setCharPref("extensions.termblaster.opened.database", this.txtDatabaseLocation.value);
    prefs.setCharPref("extensions.termblaster.opened.quicklist", this.txtQuickListLocation.value);
    prefs.setIntPref("extensions.termblaster.destination", this.rgDestination.selectedIndex);

    Components.classes["@mozilla.org/observer-service;1"]
       .getService(Components.interfaces.nsIObserverService)
       .notifyObservers(null, "TermBlasterOptions_btnOkCommand", null);

    alert('Menu changes will only be visible on new browser windows.  In some future release, changes will be immediate.');
  },

  btnResetCommand: function() {
    this.txtDatabaseLocation.selectedIndex = '0';
    this.txtQuickListLocation.selectedIndex = '1';
    this.rgDestination.selectedIndex = '1';
  },

  populate: function(menulist) {
    menulist.appendItem('chrome://termblaster/content/Services.tbd');
    menulist.appendItem('chrome://termblaster/content/QuickList.tbq');
    menulist.appendItem('chrome://termblaster/content/WithoutSupport.tbd');

/*
    var header = menulist.appendItem('Previously Opened Files:');
    header.setAttribute("disabled", "true");
    var seperator = document.createElementNS("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul", "menuseparator");
    header.parentNode.appendChild(seperator);
*/
  }
};
